# frozen_string_literal: true

module JSONAPI
  module Types
    # @see http://jsonapi.org/format/#document-resource-object-relationships
    class Relationship < Base
      attribute? :data, JSONAPI::Types::Linkage
      attribute? :meta, JSONAPI::Types::Meta
      attribute? :links, JSONAPI::Types::Links

      def identifiers
        case data
        when JSONAPI::Types::ResourceIdentifier
          [data]
        when Array
          data
        else
          []
        end
      end

      def includes?(identifier)
        identifiers.include? identifier
      end
    end
  end
end
