# frozen_string_literal: true

module JSONAPI
  module Types
    # @see http://jsonapi.org/format/#document-resource-objects
    class Resource < Base
      transform_keys { |key| { attributes: :resource_attributes }.fetch(key.to_sym, key.to_sym) }

      attribute? :id, JSONAPI::Types::ID
      attribute :type, Types::Strict::String
      # Renamed to avoid collision with Dry::Struct#attributes
      attribute? :resource_attributes, Types::JSON::Hash.default({}.freeze)
      attribute? :relationships, JSONAPI::Types::Relationships
      attribute? :links, JSONAPI::Types::Links

      def identifier
        ResourceIdentifier.new(id: id, type: type)
      end
    end
  end
end
